# zope
from Globals import InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

# silva
from Products.Silva.Publication import Publication
from Products.Silva.helpers import add_and_edit
from Products.Silva import mangle

# local
from interfaces import ILocalPublication
from LocalFolder import LocalContainerMixin
import LocalFolder

icon='www/silvapublication.gif'
addable_priority=-1.8
class LocalPublication(LocalContainerMixin, Publication):
    """ a silva publication being able to contain content objects with locale variants
    """

    __implements__ = (ILocalPublication, )
    meta_type = 'Silva Local Publication'

    def __init__(self, id, title, language):
        Publication.__init__(self, id)
        LocalContainerMixin.__init__(self, id, title, language)
        del self._title

InitializeClass(LocalPublication)

manage_addLocalPublicationForm = PageTemplateFile("www/publicationAdd", globals(),
                                                  __name__='manage_addLocalPublicationForm')


def manage_addLocalPublication(self, id, title, create_default=1, policy_name='Silva Local Document', REQUEST=None):
    """Add a LocalPublication."""
    if not mangle.Id(self, id).isValid():
        return
    language = self.get_selected_language()
    object = LocalPublication(id, title, language)
    self._setObject(id, object)
    object = getattr(self, id)
    object._setupAfterAdd()
    object.set_title(title)

    if create_default:
        policy = self.service_containerpolicy.getPolicy(policy_name)
        policy.createDefaultDocument(object, title)

    add_and_edit(self, id, REQUEST)
    return ''
