
#from Products.Localizer.Accept import AcceptLanguage
#import Products.Localizer.Accept
from itools.i18n.accept import AcceptLanguage
import itools.i18n.accept
import Products.iHotfix

# from Products.Silva.SilvaObject import SilvaObject

import zLOG

# disable the accept_language http-header parsing;
# should only use accept_path for better behaviour with caches

class AcceptLanguageDummy:

    __allow_access_to_unprotected_subobjects__ = 1

    def __init__(self, language):
        self.lang = None
        self.quality = 0.0
    
    def select_language(self, languages):        
        return self.lang
    
    def __setitem__(self, lang, quality):
        if quality > self.quality:
            self.lang = lang
            self.quality = quality

    set = __setitem__

itools.i18n.accept.AcceptLanguage = AcceptLanguageDummy
Products.iHotfix.AcceptLanguage = AcceptLanguageDummy

zLOG.LOG('SilvaLocalContent',-100,'monkey patched itools.i18n to ignore http-headers')

# patch an implements_localobject to the silva object
# XXX: not yet; partially YAGNI, partiall because it is not useful anyway
# as all objects in a LocalRoot will implement it, and none in a plain Root (?)
#def SilvaObject_implements_localobject(self):
#    return ILocalSilvaObject.isImplementedBy(self)
#
#SilvaObject.implements_localobject = SilvaObject_implements_localobject
#SilvaObject.security.declareProtected('implements_localobject',...)
#


#
# register Silva Local Document to the renderer registry as well
#

import Products.Silva
from Products.Silva.transform.rendererreg import getRendererRegistry
from Products.SilvaDocument.Document import Document
from LocalDocument import LocalDocument

def registerDefaultRenderersForSilvaLocalDocument():
    reg = getRendererRegistry()

    reg_dict = reg.getRenderersForMetaType(Document.meta_type) or {}
    for r_name, r_class in reg_dict.items():
        zLOG.LOG('SilvaLocalContent',-200,'register renderer %s for silva local document' % r_name)
        reg.registerRenderer(LocalDocument.meta_type, r_name, r_class)


#
# patch to fix with an "efficiency optimization" of the SilvaMetadata
# system, which did not take delegates into account.
# this is needed for SilvaMetadata 0.8 only, not for newer versions

from Products.SilvaMetadata.MetadataTool import MetadataTool
from Products.SilvaMetadata.Namespace import MetadataNamespace, BindingRunTime
from Products.SilvaMetadata.Binding import ObjectDelegate, encodeElement
from Acquisition import aq_base

def MetadataTool_getMetadataValue(self, content, set_id, element_id):
        """Get a metadata value right away. This can avoid
        building up the binding over and over while indexing.

        This really goes to the low-level to speed this up to the maximum.
        It's only going to work for Silva, not CMF.
        """
        # XXX how does this interact with security issues?
        set = self.collection.getMetadataSet(set_id)
        element = set.getElement(element_id)
        
        annotations = getattr(aq_base(content), '_portal_annotations_', None)

        # START changes
        bind_data = annotations and annotations[MetadataNamespace].get(BindingRunTime)
        if bind_data:
            delegate = bind_data.get(ObjectDelegate)
            if delegate:
                content = getattr(content,delegate)()
                annotations = getattr(aq_base(content), '_portal_annotations_', None)
        # END changes

        try:
            saved_data = annotations[MetadataNamespace].get(set.metadata_uri)
        except (TypeError, KeyError):
            saved_data = None
        # if it's saved, we're done
        if saved_data is not None and saved_data.has_key(element_id):
            return saved_data[element_id]
        # if not, check whether we acquire it, if so, we're done
        if element.isAcquireable():
            aqelname = encodeElement(set_id, element_id)
            try:
                return getattr(content, aqelname)
            except AttributeError:
                pass
        # if not acquired, fall back on default
        return element.getDefault(content=content)

# XXX: comment in this line if running SilvaMetadate 0.8
zLOG.LOG('SilvaLocalContent',-100,'monkey patched SilvaMetadata to check for object delegates')
MetadataTool.getMetadataValue = MetadataTool_getMetadataValue
