import time

from Acquisition import aq_base
from AccessControl.SecurityManagement import newSecurityManager, noSecurityManager

from Testing import ZopeTestCase

from test_utils import set_current_request

# TODO: add more here ?
ZopeTestCase.installProduct('ZCatalog')
ZopeTestCase.installProduct('TemporaryFolder')
ZopeTestCase.installProduct('ZCTextIndex')
ZopeTestCase.installProduct('PythonScripts')
ZopeTestCase.installProduct('PageTemplates')
ZopeTestCase.installProduct('ParsedXML')

ZopeTestCase.installProduct('iHotfix')
ZopeTestCase.installProduct('Localizer')

ZopeTestCase.installProduct('Formulator')
ZopeTestCase.installProduct('FileSystemSite')
ZopeTestCase.installProduct('XMLWidgets')
ZopeTestCase.installProduct('ProxyIndex')
ZopeTestCase.installProduct('SilvaViews')
ZopeTestCase.installProduct('SilvaMetadata')
ZopeTestCase.installProduct('Silva')
ZopeTestCase.installProduct('SilvaDocument')

ZopeTestCase.installProduct('SilvaLocalContent')

from Products.SilvaLocalContent.LocalVersionedContent import LocaleVariant 

_test_user_id='SilvaLocalTestCaseUser'

_local_variant__verifyObjectPaste = LocaleVariant._verifyObjectPaste

class SilvaLocalTestCase(ZopeTestCase.ZopeTestCase):
    " base class for all silva local content related tests "

    def getRoot(self):
        return self.app.sroot

    def _setup(self):
        # very ugly monkey to cheat the Zope security
        LocaleVariant._verifyObjectPaste = lambda self, o: None
        self.login()
        self.app.REQUEST.AUTHENTICATED_USER=self.app.acl_users.getUserById(_test_user_id)
        set_current_request(self.app.REQUEST)

        self.root = self.getRoot()
        #self.catalog = self.silva.service_catalog
        self.acceptor = self.app.REQUEST.AcceptLanguage
        

    def login(self):
        # this means all tests run with a "Manager". should they ?
        uf = self.app.acl_users
        user = uf.getUserById(_test_user_id).__of__(uf)
        newSecurityManager(None, user)

    def afterClear(self):
        # undo the monkey
        LocaleVariant._verifyObjectPaste = _local_variant__verifyObjectPaste

def setupSilvaLocalRoot(app, id='sroot', quiet=0):
    '''Creates a Silva root.'''
    if not hasattr(aq_base(app), id):
        _start = time.time()
        if not quiet:
            ZopeTestCase._print('Adding Silva Local Root... ')
        uf = app.acl_users
        uf._doAddUser(_test_user_id, '', ['Manager'], [])
        user = uf.getUserById(_test_user_id).__of__(uf)
        newSecurityManager(None, user)

        set_current_request(app.REQUEST)
        # this is needed for the fake session used by the Silva SidebarService
        factory = app.manage_addProduct['TemporaryFolder']
        factory.constructTemporaryFolder('temp_folder', '')
        
        factory = app.manage_addProduct['SilvaLocalContent']
        factory.manage_addLocalRoot(id, 'Root', languages=['en', 'la'])
        root = getattr(app, id)
        noSecurityManager()
        get_transaction().commit()
        if not quiet:
            ZopeTestCase._print('done (%.3fs)\n' % (time.time()-_start,))

# Create a Silva Local root in the test (demo-) storage
app = ZopeTestCase.app()
setupSilvaLocalRoot(app, id='sroot')
ZopeTestCase.close(app)
